commit ef6fb04bff7a0a0ee6c7c2564711d9350c3ffc22
Author: Hans Peter Schlaepfer <hanspeter.schlaepfer@revamp-it.ch>
Date:   Fri Jan 4 06:15:40 2019 +0100

    Neues kivitendo Design Aenderungen in templates/webpages/price_rule/..

diff --git a/templates/webpages/price_rule/_filter.html b/templates/webpages/price_rule/_filter.html
index d2c217f02..9705bbf2e 100644
--- a/templates/webpages/price_rule/_filter.html
+++ b/templates/webpages/price_rule/_filter.html
@@ -1,96 +1,119 @@
-[%- USE T8 %]
-[%- USE L %]
-[%- USE P %]
-[%- USE LxERP %]
-[%- USE HTML %]
-<form action='controller.pl' method='post' id='search_form'>
-<div class='filter_toggle'>
-<a href='#' onClick='javascript:$(".filter_toggle").toggle()'>[% 'Show Filter' | $T8 %]</a>
-  [% SELF.filter_summary | html %]
+[% USE T8 %]
+[% USE L %]
+[% USE P %]
+[% USE LxERP %]
+[% USE HTML %]
+
+<form action="controller.pl" method="post" id="search_form">
+
+<div class="wrapper">
+
+[% BLOCK filter_toggle_panel %]
+[%
+  # This code contains the form elements within the .filter-toggle-panel
+  # This block must bear the name filter_toggle_panel
+  # For more info have a look in common/toggle_panel.html
+%]
+<table id="filter_table" class="tbl-horizontal">
+  <caption>[% 'Part' | $T8 %]</caption>
+  <tbody>
+    <tr>
+      <th>[% 'Description' | $T8 %]</th>
+      <td>[% L.input_tag('filter.name:substr::ilike', filter.name_substr__ilike, size = 20, class="wi-normal") %]</td>
+    </tr>
+    <tr>
+      <th>[% 'Type' | $T8 %]</th>
+      <td>[% L.select_tag('filter.type', [ [ 'customer', LxERP.t8('Sales Price Rules '), ] [ 'vendor', LxERP.t8('Purchase Price Rules ') ] ], with_empty=1, default=filter.type, id='price_rule_filter_type', class="wi-normal") %]</td>
+    </tr>
+    <tr>
+      <th>[% 'Part' | $T8 %]</th>
+      <td>[% P.part.picker('filter.item_type_matches[].part', FORM.filter.item_type_matches.0.part, class="wi-normal") %]</td>
+    </tr>
+    <tr>
+      <th>[% 'Partsgroup' | $T8 %]</th>
+      <td>[% L.select_tag('filter.item_type_matches[].partsgroup', SELF.partsgroups, title_key='partsgroup', default=FORM.filter.item_type_matches.0.partsgroup, with_empty=1, class="wi-normal") %]</td>
+    </tr>
+    <tr>
+      <th>[% 'Qty' | $T8 %]</th>
+      <td>[% L.input_tag('filter.item_type_matches[].qty', FORM.filter.item_type_matches.0.qty, class="wi-normal") %]</td>
+    </tr>
+    <tr id="price_rule_filter_customer_tr"[% ' style="display:none" ' UNLESS SELF.vc== 'customer' %]>
+      <th>[% 'Customer' | $T8 %]</th>
+      <td>[% P.customer_vendor.picker('filter.item_type_matches[].customer', FORM.filter.item_type_matches.0.customer, type='customer', id='price_rule_filter_customer', class="wi-normal") %]</td>
+    </tr>
+    <tr id="price_rule_filter_vendor_tr"[% ' style="display:none" ' UNLESS SELF.vc== 'customer' %]><!-- PENDENT: Korrekt mit customer? -->
+      <th>[% 'Vendor' | $T8 %]</th>
+      <td>[% P.customer_vendor.picker('filter.item_type_matches[].vendor', FORM.filter.item_type_matches.0.vendor, type='vendor', id='price_rule_filter_vendor', class="wi-normal") %]</td>
+    </tr>
+    <tr>
+      <th>[% 'Business' | $T8 %]</th>
+      <td>[% L.select_tag('filter.item_type_matches[].business', SELF.businesses, title_key='description', default=FORM.filter.item_type_matches.0.business, with_empty=1, class="wi-normal") %]</td>
+    </tr>
+  </tbody>
+</table>
+
+<table id="filter_table" class="tbl-horizontal">
+  <caption>[% 'Dates' | $T8 %]</caption>
+  <tbody>
+    <tr>
+      <th>[% 'Reqdate' | $T8 %]</th>
+      <td>[% L.date_tag('filter.item_type_matches[].reqdate', FORM.filter.item_type_matches.0.reqdate, class="wi-date") %]</td>
+    </tr>
+    <tr>
+      <th>[% 'Transdate Record' | $T8 %]</th>
+      <td>[% L.date_tag('filter.item_type_matches[].transdate', FORM.filter.item_type_matches.0.transdate, class="wi-date") %]</td>
+    </tr>
+    <tr>
+      <th class="caption" colspan="2">[% 'Prices & Discounts' | $T8 %]</th>
+    </tr>
+    <tr>
+    <th>[% 'Pricegroup' | $T8 %]</th>
+    <td>[% L.select_tag('filter.item_type_matches[].pricegroup', SELF.pricegroups, default=FORM.filter.item_type_matches.0.pricegroup, title_key='pricegroup', with_empty=1, class="wi-normal") %]<br>
+    </td>
+    </tr>
+    <tr>
+      <th>[% 'Price' | $T8 %]</th>
+      <td>[% L.input_tag('filter.price:number', filter.price_number, size=20, class="wi-normal") %]</td>
+    </tr>
+    <tr>
+      <th>[% 'Reduced Master Data' | $T8 %]</th>
+      <td>[% L.input_tag('filter.reduction:number', filter.reduction_number, size=20, class="wi-normal") %]</td>
+    </tr>
+    <tr>
+      <th>[% 'Discount' | $T8 %]</th>
+      <td>[% L.input_tag('filter.discount:number', filter.discount_number, size=20, class="wi-normal") %]</td>
+    </tr>
+    <tr>
+      <th class="caption" colspan="2">[% 'Status' | $T8 %]</th>
+    </tr>
+    <tr>
+      <th>[% 'Priority' | $T8 %]</th>
+      <td>[% L.select_tag('filter.priority', [ [ '', LxERP.t8('All') ], [ 3, LxERP.t8('Normal') ], [ 4 , LxERP.t8('Override')]], default=filter.priority, class="wi-normal") %]</td>
+    </tr>
+    <tr>
+      <th>[% 'Obsolete' | $T8 %]</th>
+      <td>[% L.select_tag('filter.obsolete', [ [ '', LxERP.t8('Both') ], [ 0, LxERP.t8('Valid') ], [ 1 , LxERP.t8('Obsolete')]], default=filter.obsolete, class="wi-normal") %]</td>
+    </tr>
+  </tbody>
+</table>
+
+<div class="col list">
+<h3 class="caption">[% 'Has item type' | $T8 %]</h3>
+<div>
+  [% FOREACH type = SELF.all_price_rule_item_types %]
+    [% L.checkbox_tag('filter.has_item_type[]', value=type.0, label=type.1, checked=filter.has_item_type_.${type.0})  %]<br>
+  [% END %]
+</div>
 </div>
-<div class='filter_toggle' style='display:none'>
-<a href='#' onClick='javascript:$(".filter_toggle").toggle()'>[% 'Hide Filter' | $T8 %]</a>
- <table id='filter_table'>
-  <tr>
-   <th align="right">[% 'Description' | $T8 %]</th>
-   <td>[% L.input_tag('filter.name:substr::ilike', filter.name_substr__ilike, size = 20, style='width: 300px') %]</td>
-  </tr>
-  <tr>
-   <th align="right">[% 'Type' | $T8 %]</th>
-   <td>[% L.select_tag('filter.type', [ [ 'customer', LxERP.t8('Sales Price Rules '), ] [ 'vendor', LxERP.t8('Purchase Price Rules ') ] ], with_empty=1, default=filter.type, id='price_rule_filter_type', style='width: 300px') %]</td>
-  </tr>
-  <tr>
-   <th align="right">[% 'Part' | $T8 %]</th>
-   <td>[% P.part.picker('filter.item_type_matches[].part', FORM.filter.item_type_matches.0.part, style='width: 300px') %]</td>
-  </tr>
-  <tr id='price_rule_filter_customer_tr' [% "style='display:hidden' " UNLESS SELF.vc == 'customer' %]>
-   <th align="right">[% 'Customer' | $T8 %]</th>
-   <td>[% P.customer_vendor.picker('filter.item_type_matches[].customer', FORM.filter.item_type_matches.0.customer, type='customer', id='price_rule_filter_customer', style='width: 300px') %]</td>
-  </tr>
-  <tr id='price_rule_filter_vendor_tr' [% "style='display:hidden' " UNLESS SELF.vc == 'customer' %]>
-   <th align="right">[% 'Vendor' | $T8 %]</th>
-   <td>[% P.customer_vendor.picker('filter.item_type_matches[].vendor', FORM.filter.item_type_matches.0.vendor, type='vendor', id='price_rule_filter_vendor', style='width: 300px') %]</td>
-  </tr>
-  <tr>
-   <th align="right">[% 'Business' | $T8 %]</th>
-   <td>[% L.select_tag('filter.item_type_matches[].business', SELF.businesses, title_key='description', default=FORM.filter.item_type_matches.0.business, with_empty=1, style='width: 300px') %]</td>
-  </tr>
-  <tr>
-   <th align="right">[% 'Partsgroup' | $T8 %]</th>
-   <td>[% L.select_tag('filter.item_type_matches[].partsgroup', SELF.partsgroups, title_key='partsgroup', default=FORM.filter.item_type_matches.0.partsgroup, with_empty=1, style='width: 300px') %]</td>
-  </tr>
-  <tr>
-   <th align="right">[% 'Qty' | $T8 %]</th>
-   <td>[% L.input_tag('filter.item_type_matches[].qty', FORM.filter.item_type_matches.0.qty, style='width: 300px') %]</td>
-  </tr>
-  <tr>
-   <th align="right">[% 'Reqdate' | $T8 %]</th>
-   <td>[% L.date_tag('filter.item_type_matches[].reqdate', FORM.filter.item_type_matches.0.reqdate, style='width: 300px') %]</td>
-  </tr>
-  <tr>
-   <th align="right">[% 'Transdate Record' | $T8 %]</th>
-   <td>[% L.date_tag('filter.item_type_matches[].transdate', FORM.filter.item_type_matches.0.transdate, style='width: 300px') %]</td>
-  </tr>
-  <tr>
-   <th align="right">[% 'Pricegroup' | $T8 %]</th>
-   <td>[% L.select_tag('filter.item_type_matches[].pricegroup', SELF.pricegroups, default=FORM.filter.item_type_matches.0.pricegroup, title_key='pricegroup', with_empty=1, style='width: 300px') %]<br>
-   </td>
-  </tr>
-  <tr>
-   <th align="right">[% 'Price' | $T8 %]</th>
-   <td>[% L.input_tag('filter.price:number', filter.price_number, size=20, style='width: 300px') %]</td>
-  </tr>
-  <tr>
-   <th align="right">[% 'Reduced Master Data' | $T8 %]</th>
-   <td>[% L.input_tag('filter.reduction:number', filter.reduction_number, size=20, style='width: 300px') %]</td>
-  </tr>
-  <tr>
-   <th align="right">[% 'Discount' | $T8 %]</th>
-   <td>[% L.input_tag('filter.discount:number', filter.discount_number, size=20, style='width: 300px') %]</td>
-  </tr>
-  <tr>
-   <th align="right">[% 'Priority' | $T8 %]</th>
-   <td>[% L.select_tag('filter.priority', [ [ '', LxERP.t8('All') ], [ 3, LxERP.t8('Normal') ], [ 4 , LxERP.t8('Override')]], default=filter.priority, style='width: 300px') %]</td>
-  </tr>
-  <tr>
-   <th align="right">[% 'Obsolete' | $T8 %]</th>
-   <td>[% L.select_tag('filter.obsolete', [ [ '', LxERP.t8('Both') ], [ 0, LxERP.t8('Valid') ], [ 1 , LxERP.t8('Obsolete')]], default=filter.obsolete, style='width: 300px') %]</td>
-  </tr>
-  <tr>
-   <th align="right">[% 'Has item type' | $T8 %]</th>
-   <td>
-     [%- FOREACH type = SELF.all_price_rule_item_types %]
-       [%- L.checkbox_tag('filter.has_item_type[]', value=type.0, label=type.1, checked=filter.has_item_type_.${type.0})  %]
-     [%- END %]
-   </td>
-  </tr>
- </table>
 
 [% L.hidden_tag('sort_by', FORM.sort_by) %]
 [% L.hidden_tag('sort_dir', FORM.sort_dir) %]
 [% L.hidden_tag('page', FORM.page) %]
 
- [% L.button_tag("\$('#search_form').resetForm()", LxERP.t8("Reset")) %]
-</div>
+<div class="buttons"> [% L.button_tag("\$('#search_form').resetForm()", LxERP.t8("Reset Filter"), class='neutral', type='reset') %]</div>
 
+[% END #BLOCK filter_toggle_panel %]
+[% INCLUDE 'common/toggle_panel.html' %]
+
+</div>
 </form>
diff --git a/templates/webpages/price_rule/empty_item.html b/templates/webpages/price_rule/empty_item.html
index da0ae6245..b57a91ba6 100644
--- a/templates/webpages/price_rule/empty_item.html
+++ b/templates/webpages/price_rule/empty_item.html
@@ -1,4 +1,10 @@
-[%- USE L %]
-[%- USE T8 %]
-[% L.select_tag('', SELF.all_price_rule_item_types, id='price_rules_empty_item_select') %]
-<a id='price_rule_item_add' class='cursor-pointer'>[% 'Add new price rule item' | $T8 %]</a>
+[% USE L %]
+[% USE T8 %]
+<tr>
+  <td>&nbsp;</td>
+  <td>[% L.select_tag('', SELF.all_price_rule_item_types, id='price_rules_empty_item_select') %]</td>
+  <td colspan="2">
+    <a id="price_rule_item_add" class="button cursor-pointer">[% 'Add new price rule item' | $T8 %]</a>
+</td>
+</tr>
+
diff --git a/templates/webpages/price_rule/form.html b/templates/webpages/price_rule/form.html
index 70d8cf6e1..f85360574 100644
--- a/templates/webpages/price_rule/form.html
+++ b/templates/webpages/price_rule/form.html
@@ -1,45 +1,62 @@
-[%- USE T8 %]
-[%- USE L %][%- USE P %]
-[%- USE HTML %][%- USE LxERP %]
+[% USE T8 %]
+[% USE L %]
+[% USE P %]
+[% USE HTML %]
+[% USE LxERP %]
 
 <h1>[% title %]</h1>
 
-[%- INCLUDE 'common/flash.html' %]
-
- <form method="post" action="controller.pl" id="form">
-  [% L.hidden_tag("price_rule.id",   SELF.price_rule.id) %]
-  [% L.hidden_tag("price_rule.type", SELF.price_rule.type) %]
-
-  <table>
-   <tr>
-    <th align="right">[% 'Name' | $T8 %]</th>
-    <td>[% L.input_tag("price_rule.name", SELF.price_rule.name, size=60, class='initial_focus') %]</td>
-   </tr>
-   <tr>
-    <th align="right">[% 'Priority' | $T8 %]</th>
-    <td>[% L.select_tag('price_rule.priority', [ [3, LxERP.t8('Normal') ], [ 4, LxERP.t8('Override') ] ], default=SELF.price_rule.priority, style='width: 300px') %]</td>
-   </tr>
-
-   <tr>
-    <th align="right">[% 'Valid' | $T8 %]</th>
-    <td>[% L.select_tag('price_rule.obsolete', [ [ 0, LxERP.t8('Valid') ], [ 1 , LxERP.t8('Obsolete')]], default=SELF.price_rule.obsolete, title_key='description', style='width: 300px') %]</td>
-   </tr>
-
-   <tr>
-   <tr>
+[% INCLUDE 'common/flash.html' %]
+
+<form method="post" action="controller.pl" id="form">
+[% L.hidden_tag("price_rule.id",   SELF.price_rule.id) %]
+[% L.hidden_tag("price_rule.type", SELF.price_rule.type) %]
+
+<div class="wrapper">
+
+<table class="tbl-horizontal">
+  <tbody>
+    <tr>
+       <th>[% 'Name' | $T8 %]</th>
+       <td>[% L.input_tag("price_rule.name", SELF.price_rule.name, class='initial_focus wi-wide') %]</td>
+    </tr>
+    <tr>
+       <th>[% 'Priority' | $T8 %]</th>
+       <td>[% L.select_tag('price_rule.priority', [ [3, LxERP.t8('Normal') ], [ 4, LxERP.t8('Override') ] ], default=SELF.price_rule.priority, class='wi-normal') %]</td>
+    </tr>
+    <tr>
+      <th>[% 'Valid' | $T8 %]</th>
+      <td>[% L.select_tag('price_rule.obsolete', [ [ 0, LxERP.t8('Valid') ], [ 1 , LxERP.t8('Obsolete')]], default=SELF.price_rule.obsolete, title_key='description', class='wi-normal') %]</td>
+    </tr>
+  </tbody>
+</table>
+
+
+
+<div id="price_rule_items">
+  <table class="tbl-list" style="clear:left;">
+    <caption>[% 'If all of the following match' | $T8 %]:</caption>
+    <thead><tr>
+      <th class="center">X</th>
+      <th>Objekt</th>
+      <th>Bedingung</th>
+      <th>Wert</th>
+    </tr></thead>
+    <tbody>
+      [% FOREACH item = SELF.price_rule.items %]
+         [% PROCESS 'price_rule/item.html' item=item %]
+      [% END %]
+    </tbody>
+    <tbody id="price_rule_new_items"></tbody>
+    <tfoot id="price_rule_emtpy_item" class="blank">[% PROCESS 'price_rule/empty_item.html' %]</tfoot>
   </table>
+</div>
 
-<h3>[% 'If all of the following match' | $T8 %]:</h3>
-
-<div id='price_rule_items' style='margin-left: 20px;'>
-  [% FOREACH item = SELF.price_rule.items %]
-     [% PROCESS 'price_rule/item.html' item=item %]
-  [% END %]
-  <div id='price_rule_new_items'></div>
-  <div>[% PROCESS 'price_rule/empty_item.html' %]</div>
+<div class="input-panel control-panel">
+  <h3>[% 'Then' | $T8 %]…</h3>
+  <p>[% 'Set (set to)' | $T8 %] [% L.select_tag('price_rule.price_type', SELF.all_price_types, default=SELF.price_rule.price_type) %] [% 'to (set to)' | $T8 %] [% L.input_tag('price_rule.price_or_discount_as_number', SELF.price_rule.price_or_discount_as_number) %] <a id="price_rule_price_type_help" class="interact cursor-help" title="[% 'Price type explanation' | $T8 %]">[?]</a></p>
 </div>
 
-<h3>[% 'Then' | $T8 %]:</h3>
-<div>[% 'Set (set to)' | $T8 %] [% L.select_tag('price_rule.price_type', SELF.all_price_types, default=SELF.price_rule.price_type) %] [% 'to (set to)' | $T8 %] [% L.input_tag('price_rule.price_or_discount_as_number', SELF.price_rule.price_or_discount_as_number) %] <a id='price_rule_price_type_help' class='interact cursor-help' title='[% 'Price type explanation' | $T8 %]'>[?]</a>
 </div>
- </form>
+
+</form>
diff --git a/templates/webpages/price_rule/item.html b/templates/webpages/price_rule/item.html
index 291650786..7941b9e31 100644
--- a/templates/webpages/price_rule/item.html
+++ b/templates/webpages/price_rule/item.html
@@ -1,8 +1,8 @@
-[%- USE L %]
-[%- USE P %]
-[%- USE HTML %]
-[%- USE T8 %]
-[%- USE LxERP %]
+[% USE L %]
+[% USE P %]
+[% USE HTML %]
+[% USE T8 %]
+[% USE LxERP %]
 [% SET num_compare_ops = [
   [ 'eq', LxERP.t8('is equal to') ],
   [ 'le', LxERP.t8('is lower than or equal') ],
@@ -13,29 +13,52 @@
   [ 'gt', LxERP.t8('is after') ],
   [ 'lt', LxERP.t8('is before') ],
 ] %]
-<div>
-<a class='price_rule_remove_line interact cursor-pointer'>✘</a>
-[% L.hidden_tag('price_rule.items[+].id', item.id) %]
-[% L.hidden_tag('price_rule.items[].type', item.type) %]
-[%- SWITCH item.type %]
-  [% CASE 'part' %]
-    [% 'Part' | $T8 %] [% 'is' | $T8 %] [% P.part.picker('price_rule.items[].value_int', item.part) %]
-  [% CASE 'customer' %]
-    [% 'Customer' | $T8 %] [% 'is' | $T8 %] [% P.customer_vendor.picker('price_rule.items[].value_int', item.customer, type='customer') %]
-  [% CASE 'vendor' %]
-    [% 'Vendor' | $T8 %] [% 'is' | $T8 %] [% P.customer_vendor.picker('price_rule.items[].value_int', item.vendor, type='vendor') %]
-  [% CASE 'business' %]
-    [% 'Type of Business' | $T8 %] [% 'is' | $T8 %] [% L.select_tag('price_rule.items[].value_int', SELF.businesses, title_key='description', default=item.value_int) %]
-  [% CASE 'partsgroup' %]
-    [% 'Partsgroup' | $T8 %] [% 'is' | $T8 %] [% L.select_tag('price_rule.items[].value_int', SELF.partsgroups, title_key='partsgroup', default=item.value_int) %]
-  [% CASE 'qty' %]
-    [% 'Quantity' | $T8 %] [% L.select_tag('price_rule.items[].op', num_compare_ops, default=item.op) %] [% L.input_tag('price_rule.items[].value_num_as_number', item.value_num_as_number) %]
-  [% CASE 'reqdate' %]
-    [% 'Reqdate' | $T8 %] [% L.select_tag('price_rule.items[].op', date_compare_ops, default=item.op) %] [% L.date_tag('price_rule.items[].value_date', item.value_date) %]
-  [% CASE 'transdate' %]
-    [% 'Transdate Record' | $T8 %] [% L.select_tag('price_rule.items[].op', date_compare_ops, default=item.op) %] [% L.date_tag('price_rule.items[].value_date', item.value_date) %]
-  [% CASE 'pricegroup' %]
-    [% 'Pricegroup' | $T8 %] [% 'is' | $T8 %] [% L.select_tag('price_rule.items[].value_int', SELF.pricegroups, title_key='pricegroup', default=item.value_int) %]
-  [% CASE %]
-[%- END %]
-</div>
+
+<tr class="item">
+  <td>
+    <a class="price_rule_remove_line interact cursor-pointer button">✘</a><!-- PENDENT: das Loeschzeichen sollte einheitlich angewendet werden. -->
+    [% L.hidden_tag('price_rule.items[+].id', item.id) %]
+    [% L.hidden_tag('price_rule.items[].type', item.type) %]
+  </td>
+
+  [% SWITCH item.type %]
+    [% CASE 'part' %]
+      <td>[% 'Part' | $T8 %]</td>
+      <th>[% 'is' | $T8 %]</th>
+      <td>[% P.part.picker('price_rule.items[].value_int', item.part,, class='wi-wide') %]</td>
+    [% CASE 'customer' %]
+      <td>[% 'Customer' | $T8 %]</td>
+      <th>[% 'is' | $T8 %]</th>
+      <td>[% P.customer_vendor.picker('price_rule.items[].value_int', item.customer, type='customer', class='wi-wide') %]</td>
+    [% CASE 'vendor' %]
+      <td>[% 'Vendor' | $T8 %]</td>
+      <th>[% 'is' | $T8 %]</th>
+      <td>[% P.customer_vendor.picker('price_rule.items[].value_int', item.vendor, type='vendor', class='wi-wide') %]</td>
+    [% CASE 'business' %]
+      <td>[% 'Type of Business' | $T8 %]</td>
+      <th>[% 'is' | $T8 %]</th>
+      <td>[% L.select_tag('price_rule.items[].value_int', SELF.businesses, title_key='description', default=item.value_int, class='wi-wide') %]</td>
+    [% CASE 'partsgroup' %]
+      <td>[% 'Partsgroup' | $T8 %]</td>
+      <th>[% 'is' | $T8 %]</th>
+      <td>[% L.select_tag('price_rule.items[].value_int', SELF.partsgroups, title_key='partsgroup', default=item.value_int, class='wi-wide') %]</td>
+    [% CASE 'qty' %]
+      <td>[% 'Quantity' | $T8 %]</td>
+      <th>[% L.select_tag('price_rule.items[].op', num_compare_ops, default=item.op, class='wi-normal' ) %]</th>
+      <td>[% L.input_tag('price_rule.items[].value_num_as_number', item.value_num_as_number, class='wi-small') %]</td>
+    [% CASE 'reqdate' %]
+      <td>[% 'Reqdate' | $T8 %]</td>
+      <th>[% L.select_tag('price_rule.items[].op', date_compare_ops, default=item.op, class='wi-normal') %]</th>
+      <td>[% L.date_tag('price_rule.items[].value_date', item.value_date,, class='wi-date') %]</td>
+    [% CASE 'transdate' %]</td>
+      <td>[% 'Transdate Record' | $T8 %]</td>
+      <th>[% L.select_tag('price_rule.items[].op', date_compare_ops, default=item.op, class='wi-normal') %]</th>
+      <td>[% L.date_tag('price_rule.items[].value_date', item.value_date,, class='wi-date') %]</td>
+    [% CASE 'pricegroup' %]
+      <td>[% 'Pricegroup' | $T8 %]</td>
+      <th>[% 'is' | $T8 %]</th>
+      <td>[% L.select_tag('price_rule.items[].value_int', SELF.pricegroups, title_key='pricegroup', default=item.value_int, class='wi-wide') %]</td>
+    [% CASE %]
+  [% END %]
+
+</tr>
diff --git a/templates/webpages/price_rule/price_type_help.html b/templates/webpages/price_rule/price_type_help.html
index 608d34541..905f5d371 100644
--- a/templates/webpages/price_rule/price_type_help.html
+++ b/templates/webpages/price_rule/price_type_help.html
@@ -2,32 +2,25 @@
 [% 'Matching Price Rules can apply in one of three types:' | $T8 %]
 
 <h3>[% 'Price' | $T8 %]</h3>
-
 <p>
-[% 'This will set an exact price.' | $T8 %]
-[% 'It will not be further modified by any other source, and will be offered in records like this.' | $T8 %]
+  [% 'This will set an exact price.' | $T8 %]
+  [% 'It will not be further modified by any other source, and will be offered in records like this.' | $T8 %]
 </p>
 
 <h3>[% 'Reduced Master Data' | $T8 %]</h3>
-
 <p>
-[% 'This will reduce the appropriate Master Data price by this in percent points.' | $T8 %]
-[% 'This will happen before the price is offered, and the reduction will not be printed in documents.' | $T8 %]
-[% 'Negative reductions are possible to model price increases.' | $T8 %]
+  [% 'This will reduce the appropriate Master Data price by this in percent points.' | $T8 %]
+  [% 'This will happen before the price is offered, and the reduction will not be printed in documents.' | $T8 %]
+  [% 'Negative reductions are possible to model price increases.' | $T8 %]
 </p>
-
 <p>[% 'Example' | $T8 %]:</p>
-
 <pre>[% 'Set (set to)' | $T8 %] [% 'Reduced Master Data' | $T8 %] [% 'to (set to)' | $T8 %] 3</pre>
-
 <p>
-[% 'This will apply a 3% reduction to the master data price before entering it into the record item.' | $T8 %]
+  [% 'This will apply a 3% reduction to the master data price before entering it into the record item.' | $T8 %]
 </p>
-
 <h3>[% 'Discount' | $T8 %]</h3>
-
 <p>
-[% 'This will be treated as a discount in percent points.' | $T8 %]
-[% 'Contrary to Reduced Master Data this will be shown as discount in records.' | $T8 %]
-[% 'The discounted amount will be shown in documents.' | $T8 %]
+  [% 'This will be treated as a discount in percent points.' | $T8 %]
+  [% 'Contrary to Reduced Master Data this will be shown as discount in records.' | $T8 %]
+  [% 'The discounted amount will be shown in documents.' | $T8 %]
 </p>
diff --git a/templates/webpages/price_rule/report_bottom.html b/templates/webpages/price_rule/report_bottom.html
index e61821280..331bade34 100644
--- a/templates/webpages/price_rule/report_bottom.html
+++ b/templates/webpages/price_rule/report_bottom.html
@@ -1,4 +1,5 @@
 [% USE L %]
 [% USE T8 %]
 [% USE HTML %]
-[%- L.paginate_controls(models=SELF.models) %]
+[% L.paginate_controls(models=SELF.models) %]
+</div><!-- /.wrapper -->
diff --git a/templates/webpages/price_rule/report_top.html b/templates/webpages/price_rule/report_top.html
index 1b5dad5d4..65cff87c2 100644
--- a/templates/webpages/price_rule/report_top.html
+++ b/templates/webpages/price_rule/report_top.html
@@ -1,3 +1,5 @@
-[%- USE L %]
-[%- PROCESS 'price_rule/_filter.html' filter=SELF.models.filtered.laundered UNLESS FORM.inline %]
- <hr>
+[% USE L %]
+
+[% PROCESS 'price_rule/_filter.html' filter=SELF.models.filtered.laundered UNLESS FORM.inline %]
+
+<div class="wrapper">